APIO 的题怎么都这么毒瘤啊

# [APIO2020] 粉刷墙壁

​ 将长度为 nn 的墙壁涂色,共有 kk 种颜色,第 ii 段墙壁期望的颜色为 cic_i 。有 mm 个粉刷公司,第 ii 个粉刷公司可以涂 aia_i 种颜色(是给定的)。现在可以提出若干个形如 xy(0≤x<m,0≤y≤n−m)x\;y\;(0\le x<m,0\le y\le n-m) 的要求,只有当对于所有的 0≤i<m0\le i< m ,第 (x+i)modm(x+i)\bmod m 个公司可以涂第 y+iy+i 段墙壁,则会将这些墙壁全部涂上色。每一段墙壁可以被涂色多次,但每次必须都是它所期望的颜色 cic_i 。最小化提出的要求数,若无法满足期望颜色输出 -1。

​ 1≤n≤1051\le n\le 10^5 ,1≤m≤min⁡(n,5×104)1\le m\le \min(n,5\times 10^4) ,1≤k≤1051\le k\le 10^5 。

​ 设 fif_i 表示可以涂第 ii 种颜色的公司数量,则 ∑fi2≤4×105\sum{f_i}^2\le 4\times 10^5 。


我们显考虑如何统计答案,我们发现一次请求对应的就是涂上区间 [y,y+m−1][y,y+m-1] ,那么发现这就变成了一个简单的区间覆盖问题,直接贪心地不断扩展右端点即可。那我们现在要做的就是如何找到这些区间,也就是找到那个对应的 xx 。我们先考虑一个朴素的 dp ,设 fi,jf_{i,j} 表示从第 ii 段墙壁第 jj 个公司开始匹配最多能涂几段墙,转移显然。若能涂 fi,j=fi+1,(j+1)modm+1f_{i,j}=f_{i+1,(j+1)\bmod m}+1 ,否则 fi,j=0f_{i,j}=0 。若 fi,j≥mf_{i,j}\ge m 说明 [i,i+m−1][i,i+m-1] 为一个区间。哦那个是滚动数组优化一下,此时时间复杂度为 O(nm)O(nm) ,考虑优化。发现我们转移时只需要能涂的,所以我们可以变为枚举可以涂第 ii 段墙壁的公司直接进行转移,由于 ∑fi2≤4×105\sum{f_i}^2\le 4\times 10^5 ,所以时间复杂度有保证。

# [APIO2020] 交换城市

​ 给定 nn 个点和 mm 条边的无向图,每条边有边权。有 QQ 次询问,每次询问 u,vu,v 两点是否可以互达,要求不能相遇,若能互达最小化路径上边权的最大值,否则输出 -1,强制在线。

​ 2≤n≤1052\le n\le 10^5 ,m≤2×105m\le 2\times 10^5 ,Q≤2×105Q\le 2\times10^5 。


前置知识: KruskalKruskal 重构树

​ 我们在 KruskalKruskal 求最小生成树的过程中,对于边 (u,v)(u,v) ,当我们合并两个连通块fau,favfa_u,fa_v 的时候,我们新建一个点 xx ,其点权为新加的那条边的权值,然后连边 (x,fau),(x,fav)(x,fa_u),(x,fa_v) ,再让 fau=fav=xfa_u=fa_v=x 即可。时间复杂度为 O(nlog⁡n+mlog⁡m)O(n\log n+m\log m) 。

​ 性质:共有 2n−12n-1 个节点。其中叶子节点都是原树上的节点,其余节点表示某条边的边权。原图中两个点之间的路径上最大边权的最小值为 KruskalKruskal 重构树上两个节点的 LCALCA 的点权。(若求两个节点的最小边权的最大值跑最大生成树即可)


我们先考虑几个简单的性质,当 u,vu,v 所在连通块是一条链的时候显然无解,当其连通块有一个点的度数 ≥3\ge 3 时必定有解,或者它就是一个环的时候也有解。

发现这道题我们额外做的就是在做 KruskalKruskal 重构树的时候去维护这些连通块的信息,我们主要考虑去处理链的情况。假如我们要处理边 (u,v,w)(u,v,w) ,再设 fau=p,fav=qfa_u=p,fa_v=q 。

当 u,vu,v 已经连通的时候,我们看一下这个连通块是不是一条链,也就是说我们还需要维护一个数组表示连通块是否还是一条链的形态,如果是一条链,它再加一条边必然就不是链了,所以我们修改一下标记。此时我们有一个神奇的操作,当链变为非链时,我们在重构树上新建节点,点权为 ww ,让它向所有原来链上的点连一条边,再将这个连通块的 rootroot 设为该点。显然这不影响重构树用 LCALCA 求解的性质,而且可以使得求出的一定为非链的情况。

当 u,vu,v 不连通时,我们发现,若其中有一个为非链,那么合并完也必然非链,所以我们直接对为链的那个连通块(也可能没有)进行连边操作,合并两个连通块并将标记设为非链形态。但是也有可能两个都是链,那我们还需要分类讨论一下。若点 u,vu,v 都是两条链的某个端点,那它合并完仍然是一条链,所以我们直接修改新链的 p1,p2p1,p2 两端点即可。否则,它合并后一定为非链,直接将两个连通块全进行加边操作即可。

此时我们就完美用 KruskalKruskal 重构树解决了询问,最后我们只需要求两点 LCALCA 即可,其点权就是答案了。注意最后建出的是一颗森林,则无解当且仅当两个点不在同一棵树上,这个 dfsdfs 的时候直接处理一下即可。总时间复杂度为 O(nlog⁡n+Qlog⁡n)O(n\log n+Q\log n) 。

# [APIO2021] 封闭道路

​ 给定一棵 nn 个结点的树,每条边有边权。对于 0≤x<n0\le x<n ,删掉一些边使每个结点的度数不大于 xx ,求删掉的边的权值和最小值。

​ n≤250000n\le 250000 。


我们先从暴力入手,我们设 fu,0/1f_{u,0/1} 表示 uu 与父亲的边删 / 不删时以 uu 为根的子树满足所有节点度数 ≤x\le x 时的答案。设 did_i 表示节点 ii 的度数,我们先不考虑点 uu 的度数限制,此时答案显然为 ∑v∈sonumin⁡(fv,0,fv,1+w)\sum_{v\in son_u}\min(f_{v,0},f_{v,1}+w) 。我们考虑上点 uu 的度数,我们假设满足 min⁡(fv,0,fv,1+w)=fv,1+w\min(f_{v,0},f_{v,1}+w)=f_{v,1}+w 的儿子有 cntcnt 个,此时它的度数为 du−cntd_u-cnt ,还需要删 du−cnt−xd_u-cnt-x 个儿子。我们可以想到维护一个小根堆,将所有不满足 min⁡(fv,0,fv,1+w)=fv,1+w\min(f_{v,0},f_{v,1}+w)=f_{v,1}+w 的儿子 fv,1+w−fv,0f_{v,1}+w-f_{v,0} 的值扔进去,取出来前 du−cnt−xd_u-cnt-x 个即可,设和为 sumsum ,这样答案为 sum+∑v∈sonufv,0sum+\sum_{v\in son_u}f_{v,0} ,单次时间复杂度为 O(nlog⁡n)O(n\log n) ,总时间复杂度为 O(n2log⁡n)O(n^2\log n) 。

这个暴力将是我们正解的重要基础。我们枚举 xx 的时候,必然会有很多信息是重复计算的,我们考虑从小到大枚举 xx ,若某个点的 du≤xd_u\le x ,容易发现在后面的计算中这个点已经没用了,我们定义这样的点为无用点。所以我们再求解的时候,可以只对有用点进行遍历,将无用点当成叶子去处理,但无用点必然还是会对父亲有影响的,我们来考虑计算无用点的贡献,由于它度数已经满足要求了,所以其 ff 值均为 00 ,所以贡献就是边权 ww ,扔到堆里。然后再考虑那些有用点,它们的贡献计算方法与暴力相同。当我们处理好堆中的元素时,我们直接暴力取需要的元素即可。而且容易发现无用点的计算是永久的,而有用点的计算可能只是临时的。所以我们可以在计算结束后撤销对有用点的贡献,同时我们在求答案的时候可能会删掉无用点的贡献,所以我们还需要撤销对无用点的删除操作。那么此时我们就需要一个支持可撤销添加或删除操作的堆,我们可以用两个堆去维护,一个堆维护插入的元素,另一个堆维护删除的元素,sizesize 就是两个堆的 sizesize 之差,求堆顶要先把两个堆相同的元素弹出去再取插入的堆的 top 即可。算是一个可撤销堆的 trick 吧。对于时间复杂度,每个点最多会成为有用点 did_i 次, ∑di=2n−2\sum d_i=2n-2 ,所以时间复杂度可以控制在 O(nlog⁡n)O(n\log n) ,实现细节较多。

# [APIO2021] 雨林跳跃

​ 给定一个长度为 nn 的序列 aa 。有 QQ 次询问,每次询问给定四个正整数 A,B,C,DA,B,C,D ,求能否从 [A,B][A,B] 中的任意一个点出发到达 [C,D][C,D] 中的某个点。移动方式为:假设现在在位置 xx ,一次移动可以到左面或右面比 axa_x 大的第一个位置。若能到达输出最小移动步数,否则输出 -1。

​ 2≤n≤2×1052\le n\le 2\times 10^5 ,1≤Q≤1051\le Q\le 10^5 。


我们先预处理出每个点向左右跳一次可以到达的点 Li,RiL_i,R_i ,这个显然可以单调栈求出。然后我们逐渐地考虑这个问题。

我们先考虑 A=BA=B 且 C=DC=D 的情况,发现也就是询问从 AA 出发能否到 CC 。先考虑无解的情况,发现当 [A,C−1][A,C-1] 中的最大值 aposa_{pos} 大于 aCa_C 时无解,因为无论怎么移动 pospos 都会拦住你到 CC ,而你一旦到达 pospos 后只能往更大的位置移动也就永远到不了 CC 了。此时发现 pospos 这个位置似乎很关键,我们从这里入手解决有解的情况,因为从 pospos 是可以一步向右跳到 CC 的,所以我们考虑怎么能最小步数到达 pospos 。很容易发现我们只需不断跳左右两边的较大值,直到较大值大于等于 aposa_{pos} 了。假如左边大于 aposa_{pos} ,我们需要不断往右跳,若是右边显然较大值就是 aposa_{pos} 了,直接跳过去即可,综上我们直接再往右跳即可。但是也很容易举出反例,就是我们跳到左边一个比 aposa_{pos} 更大的点,再直接跳到 CC ,这是可行的。但我们可以发现,当 aLpos<aCa_{L_{pos}}<a_C 时, 它向左跳到 LposL_{pos} 是最优的,因为 LposL_{pos} 到 CC 的值都小于 aposa_{pos} ,所以 LposL_{pos} 是 AA 左边最靠右的可以一步跳到 CC 的位置,但记住前提是 aLpos<aCa_{L_{pos}}<a_C 。所以将这两种情况取个 min⁡\min 即可。我们举个例子,假如序列为 8,7,4,3,5,6,9,11,10,138,7,4,3,5,6,9,11,10,13 ,A=4,C=10A=4,C=10 ,以下用位置的值来代表这个位置。发现 pospos 为 1111 ,按照第一种类型,我们从 33 出发,先跳到 55 ,再跳到 77 ,再跳到 99 ,再跳到 1111 ,最后跳到 1313 。再以 4,1,2,3,54,1,2,3,5 为例,A=1,C=5A=1,C=5 ,发现 pospos 为 33 ,我们直接跳到 LposL_{pos} 44 再直接跳到 55 。

我们再考虑只有 C=DC=D 的情况,首先无解情况显然与上面相同。发现我们就是要找一个出发点。我们沿用上面的两种情况,如果我们要经过 pospos ,我们的出发点显然要在 LposL_{pos} 右面,否则它往右跳一定会到 LposL_{pos} 进而到不了 pospos ,同时贪心地想,显然还要以值最大的那个位置为起点,然后再按照第一种情况处理即可。我们再考虑不经过 pospos 的情况,前提仍然是 aLpos<aCa_{L_{pos}}<a_C 。事实上就是找到能到 LposL_{pos} 的点,如果 LposL_{pos} 就在 [A,B][A,B] 中直接以它为起点就好,否则 LposL_{pos} 一定在 AA 的左面,那么我们可以贪心地选取 [A,B][A,B] 中值最大的点,然后以左右选较大值的方式跳到 LposL_{pos} 再一步到 CC 。同理两种情况取个 min⁡\min 即可。

最后我们来考虑没有其它限制的情况,发现我们只需要考虑能否到达 [C,D][C,D] 中的某个位置。无解情况类似,就是 [C,D][C,D] 的最大值比 aposa_{pos} 要小。我们再按照两种情况分析。如果我们要跳到 pospos ,发现它就一定可以跳到 [C,D][C,D] 中了,因为 [C,D][C,D] 中一定存在某个位置值大于 aposa_{pos} ,这就和上面一样了。然后我们考虑利用 LposL_{pos} 的情况,发现与上面的情况几乎一模一样,只有前提条件变为 aLposa_{L_{pos}} 小于 [C,D][C,D] 中的最大值,也就是要保证从 LposL_{pos} 能跳过去。

最后跳的这个过程怎么求解,发现直接倍增即可。时间复杂度为 O(nlog⁡n+Qlog⁡n)O(n\log n+Q\log n) 。

# [APIO2022] 游戏

​ 有 nn 个点,编号为 00 到 n−1n-1 。编号为 00 到 k−1k-1 为特殊点。对于 0≤i≤k−20\le i\le k-2 ,初始有有向边 (i,i+1)(i,i+1) 。接下来给 TT 个操作,每个操作会给定 uu vv ,表示新加一个从 uu 指向 vv 的有向边(添加后这条边会一直存在)。若在加入这条边后,出现了一个包含特殊点的环,输出 11 并结束程序,否则输出 00 并接着读入。

​ 1≤n≤3×1051\le n\le 3\times 10^5 ,1≤T≤5×1051\le T\le 5\times 10^5 ,1≤k≤n1\le k\le n 。


神仙题目。考虑设 lul_u 表示可以到达点 uu 的编号最大的特殊点,rur_u 表示 uu 可以到达的编号最小的特殊点。如果不存在值分别为 −1,k-1,k 。那么容易发现存在环当且仅当存在点 uu 其 lu≥rul_u\ge r_u 。所以我们就有了一个暴力的思路,每次加边之后直接暴力 dfsdfs 正图和反图去维护 ll 和 rr 数组。然后我们考虑去怎么优化这个过程,我们可以把 [lu,ru][l_u,r_u] 看成区间,直接上一棵权值线段树,根节点的区间为 [−1,k][-1,k] 。再没有环的时候它们就可以构成合法区间。初始时显然特殊点都是叶子节点,非特殊点都是根节点。我们考虑只记录能包含区间 lu,rul_u,r_u 的最小区间对应的线段树节点 trutr_u ,也就是说,我们的 ll 和 rr 数组只会记录到对应的线段树节点的区间。首先发现如果有有向边边 (u,v)(u,v) ,那么 lv=max(lu,lv),ru=min⁡(ru,rv)l_v=max(l_u,l_v),r_u=\min(r_u,r_v) 。基于这个性质,我们对 trutr_u 和 trvtr_v 进行处理。我们来对 trutr_u 和 trvtr_v 的关系进行分类。

若 trutr_u 与 trvtr_v 相离,显然只有 rv<lur_v<l_u 时,更新后会出现 rv<lu≤lv,ru≤rv<lur_v<l_u\le l_v,r_u\le r_v<l_u ,也就是都变成不合法区间形成环了,那我们直接判断即可。同时这也就是判断能否成环的最基本方法。

若 trutr_u 和 trvtr_v 是同一个节点(非叶子节点),此时 lu=lv,ru=rvl_u=l_v,r_u=r_v ,显然不会成环,直接 return 即可。(这里我们进行一个正确性证明,假如我们现在 ll 和 rr 表示真实值,那么它们的 trtr 在同一个节点说明两个区间有交,手模一下发现更新后也不会出现不合法区间,所以不影响正确性)。

若 trutr_u 和 trvtr_v 有包含关系,也就是说它们有父子关系。我们先设 midumid_u 和 midvmid_v 分别表示 [lu,ru][l_u,r_u] 和 [lv,rv][l_v,r_v] 的中点。我们有四种情况:一是 vv 在 uu 的左儿子内,即 rv≤midur_v\le mid_u ,这样更新后 rur_u 就会变为 rvr_v ,trutr_u 也会随之改边,但是按照我们的做法,我们只需把 rur_u 先改为 midumid_u 即可。二是 vv 在 uu 的右儿子内,即 lv>midul_v>mid_u ,但此时 trutr_u 是不会改变的。三是 uu 在 vv 的左儿子内,即 ru≤midvr_u\le mid_v ,此时 trvtr_v 也不会改变。最后是 uu 在 vv 的右儿子内,即 mid<lumid<l_u ,此时 lvl_v 会变成 lul_u ,同情况一我们只需要将 lvl_v 变成 midv+1mid_v+1 即可。我们发现情况二和情况三不会改变 trtr 的值,所以我们不用处理它。然后我们单独看情况一和情况四,由于它们的 trtr 发生了改变,那么按照判断环的方式,它们是有可能成环的,所以我们需要处理。我们直接遍历 trtr 改变的那个点的所有邻边再判断是否成环,别忘了还要遍历反图中的邻边,不断这样递归下去即可。只要出现环直接 return 即可。由于每个 trtr 只会变化 log⁡k\log k 次,同时每次还会遍历邻边,所以总时间复杂度为 O(mlog⁡k)O(m\log k) 。

# [APIO2022] 排列

​ 构造一个含有 kk 个上升子序列的排列(从 00 开始,包括空序列)。要求序列长度 ≤90\le 90 。

​ 2≤k≤10182\le k\le 10^{18} 。


先说一个很无脑的想法,直接构造一个长度为 kk 的递减序列。可以获得 1010 分的成绩。

我们考虑 11 到 xx 的一个递增序列,发现其任意一个子序列都是递增的,所以有 2x2^x 个上升子序列。由此我们可以想到将 kk 二进制拆分,先假设其最大项为 2x2^x ,那么我们可以先来一个 00 到 x−1x-1 。每出现一个 2x2^x ,我们就在当前序列的第 xx 项后面添加 11 个严格大于当前序列中所有数的数。举个例子,现在 k=24+22+20k=2^4+2^2+2^0 ,初始序列为 0,1,2,30,1,2,3 ,我们要出现一个 222^2 ,那我们在 11 的后面加一个 44 ,变成 0,1,4,2,30,1,4,2,3 ,这样 44 就可以产生 222^2 个上升子序列,对于 202^0 ,我们在最前面放一个 55 即可。最终得到 5,0,1,4,2,35,0,1,4,2,3 。按照这样最后序列的长度为 log⁡2k+popcount(k)−1\log_2 k+popcount(k)-1 。但发现 1018<26010^{18}<2^{60} ,那么对于 259−12^{59}-1 ,它就需要 58+58−1=11558+58-1=115 个数,还是超出了限制,我们继续考虑优化。

发现最开始的那 log⁡2k\log _2k 个数的骨架是很难减掉了。发现 90=1.5×6090=1.5\times 60 ,我们就有一个非常妙的想法:能不能把两个 11 尝试用一个 11 表示出来。发现这个想法是可行的!我们以序列 0,4,1,6,2,5,30,4,1,6,2,5,3 为例,初始序列是 0,1,2,30,1,2,3 ,产生 242^4 个上升子序列。然后我们加了一个 55 ,产生了 232^3 个子序列,然后又加了一个 66 ,产生了 222^2 个子序列,然后我们又加了一个 44 ,它可以和 00 以及后面的 6,56,5 共产生 20+20×2=20+212^0+2^0\times 2=2^0+2^1 个子序列。这样这个 44 就起到了用一个表示两个的作用。一般地,在我们得到初始序列后,我们按二进制位从大到小先找到两个 11 作为这个操作的基础,并添加两个递减的数,记录下最大值和次大值的位置。然后我们继续往后找 11 ,每找到两个连续的 11 ,我们就可以按照刚刚例子的操作,先把那两个最大值和次大值加 11 ,然后在对应的位置添加一个原来作为次大值的值,这压根就可以产生 33 倍的贡献。而如果不是两个连续的 11 ,我们就按照上面的方案,直接插入一个比当前最大值加 11 的数,并修改最大值和次大值位置即可。这样序列长度就可以控制在 1.5log⁡k1.5\log k 了,可以得到满分。

# [APIO2018] 新家

​ 在一条数轴上会出现 nn 个点,每个点有颜色、位置、出现时间和消失时间,共有 kk 种颜色。接下来有 QQ 个询问,每次询问为:在时间 tt 对于位置 pospos ,每种颜色的点到 pospos 的最小距离的最大值。若在时间 tt 并不存在所有 kk 种颜色的点,输出 -1。

​ 1≤n,Q≤3×1051\le n,Q\le 3\times 10^5 ,1≤k≤n1\le k\le n 。

位置和时间的值域范围为 [1,108][1,10^8] 。


我们先考虑怎么处理时间的限制,这很容易想到将所有点的出现时间、消失时间以及询问一起离线下来排个序。然后我们考虑这种区间数颜色的操作,经典的操作是对于每个位置记录与其颜色种类相同的上一个位置,而这里由于每个位置上可能出现多个点,所以我们每个位置(也就是叶子节点)开一个 multisetmultiset 维护该位置上所有颜色的点对应的前驱,区间直接维护其前驱最小值。同时我们对于每种颜色的点还要开一个 multisetmultiset 记录其出现的位置,还要先插入两个哨兵商店,这样可以很方便的查找其前驱后继。具体地,若新加一个点位置为 pospos ,我们找到该点的前驱 aa 和后继 bb ,我们将 bb 的前驱修改为它自己,也就是将位置 bb 的 multisetmultiset 删去 aa 而插入 pospos ,再将 pospos 的前驱修改为 aa ,再看其 sizesize 是否为 22 ,若是 22 则说明该种颜色的点原先没有而现在有了,所以该时刻的颜色种类数要加一,同时对应颜色的 multisetmultiset 还要插入 pospos 。删除的处理与插入类似。对于询问,我们可以通过二分长度 lenlen ,若 [x−len,x+len][x-len,x+len] 包含了所有的 kk 种颜色,那么 lenlen 合法。怎么判断是否包含所有颜色呢,我们利用记录的前驱最小值,若 r+1r+1 往后的位置前驱最小值小于 ll ,说明一定有某种颜色没有在 [l,r][l,r] 内出现。这样单次时间复杂度为 log⁡2n\log ^2n 。我们可以直接线段树上二分位置,这样时间复杂度可以做到 O(nlog⁡n+Qlog⁡n)O(n\log n+Q\log n) 。

# [APIO2018] 铁人两项

​ 给定一张 nn 个点 mm 条边的无向图,问有多少三元组 (a,b,c)(a,b,c) 满足存在一条简单路径,从 aa 出发经过 bb 到达 cc 。

​ n≤105n\le 10^5 ,m≤2×105m\le 2\times 10^5 。


我们发现当 aa 和 cc 确认时 bb 的数量就是 aa 到 cc 的所有简单路径的并的大小减二(减去 aa 和 cc 两个点)。此时可以用到点双连通分量的一个性质:对于同一个点双中的两个点其简单路径的并集恰好为整个点双。所以 aa 到 cc 的简单路径的并还等于 aa 到 cc 经过的所有点双的并集。我们直接建出原图的圆方树,这样两点间路径就和其在圆方树上的路径经过的圆点和方点有关。这里我们运用一个小技巧,对圆方树上的点赋上点权。我们在这里将方点点权设为点双的大小,圆点点权设为 -1。手模一下发现此时两点间简单路径的并的大小减二就等于圆方树上两点路径上经过的点的权值和。此时问题就转化为统计圆方树上两圆点间路径的权值和。这是经典问题,我们可以考虑每个点对答案的贡献,直接 dfs 即可。时间复杂度为 O(n+m)O(n+m) 。

更新于

请我喝[茶]~( ̄▽ ̄)~*

YC乌龙 微信支付

微信支付

YC乌龙 支付宝

支付宝

YC乌龙 贝宝

贝宝